#include <octave/config.h>
#include <octave/defun-dld.h>
#include <octave/error.h>
#include <octave/oct-obj.h>
#include <octave/pager.h>
#include <octave/symtab.h>
#include <octave/variables.h>
#include <octave/help.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include "oct-engine.h"

// DEFUN_DLD and the macros that it depends on are defined in the
// files defun-dld.h, defun.h, and defun-int.h.
DEFUN_DLD (mclose, args, nargout,
  "[errno] = mclose(msgid)\n\
\n\
Use mclose to close a message queue msgid.")
{    
    // The list of values to return.  See the declaration in oct-obj.h
    octave_value_list retval;

    // The arguments to this function are available in args.
    int nargin = args.length ();
    if (nargin != 1) {
	error ("mclose: need one argument");
	return retval;
    }

    int msgid = (int)args(0).double_value();

    if (msgctl(msgid, IPC_RMID, NULL) == -1) {
	error("mclose: can not msgctl");
	return retval;
    }
    
    retval(0) = octave_value(0.);
    return retval;
}





